var container, stats;

var camera, scene, renderer, controls, uniforms;

var clock = new THREE.Clock();

var texture;
var material;

var MouseX = 0, MouseY = 0;
var PrevMouseX = 0;
var PrevMouseY = 0;

var waitNb = 11;
var waitCount = 0;
var AllIsLoaded = false;

var windowHalfX = window.innerWidth / 2;
var windowHalfY = window.innerHeight / 2;

var ScreenRef = 1080.0;
var CamBaseZoom = 0.005;
var CamZoom = CamBaseZoom;

var drawBackface = false;

var AllObj = [];
var AllEnemies = [];

var CurrentLevel;
var CurrentLevelLoaded = false;

var EnemyNb = 1;

var TickRate = 60;
var FixedDeltaTime = 1.0/TickRate;

var LastTickTime = 0.0;
var TickStarted = false;
var RestTickTime = 0.0;

var MainCharacter;
var MainRandom = [];
var MainPivot = [];
var MainMotion = [];
var MainTex;
var MainUni;
var MainCharacLoaded = false;
var MainCharacterMesh;

var LevelMat;
var LevelUni;
var LevelTex;
var LevelBackgroundTex;
var LevelGroundTex;
var LevelDebugMesh;

var CharacReplay = [];
var CharacReccord = [];
var CharacReplayNumber = 5;
var CharacSpawnerIdx = 4;
var CurrentReccord = 0;
var MaxReccord = 0;

var CurrentRespawnPosition;
var ReccordDurationFrame = 60 * 10.0;

var Interface;
var InterfTex;
var InterfRandom = [];
var InterfLoaded = false;
var TimeBarMesh;
var CrossMesh;
var CrossTex;

var BackMesh;
var TitleMat;
var TitleMesh;
var TitleTex1;
var TitleTex2;
var TitleClic1 = false;
var TitleClic2 = false;
var TitleClic3 = false;

var DebugPlanes = [];

var NextRandomChange = 0;
var TmpRandVal = 0;

var InputSample = new ReccordSample();

var ReccordFinish = false;
var ReplayFinish = false;
var ReplayTickFrame = 0;
var ReccordTickFrame = 0;

var Particles = [];
var ParticleTex;

init();
animate();

function on_interf_load( object ) {

	var dae = object.scene;
	dae.updateMatrix();
	
	var LastFoundMesh;

	dae.traverse( function ( child ) {

		if ( child instanceof THREE.Mesh ) {
			child.material = InterfMaterial;
			LastFoundMesh = child;
		}

	} );
	
	Interface = new THREE.Mesh( LastFoundMesh.geometry, LastFoundMesh.material );
			
	var TimeBarGeom = new THREE.PlaneGeometry( 1, 1 );
	var TimeBarMat = new THREE.MeshBasicMaterial(  );
	TimeBarMat.transparent = true;
	
	TimeBarMesh = new THREE.Mesh( TimeBarGeom, TimeBarMat );
	
	var TitleGeom = new THREE.PlaneGeometry( 5, 5 );
	TitleMat = new THREE.MeshBasicMaterial(  );	
	TitleMat.map = TitleTex1;
	TitleMat.transparent = true;
	TitleMesh = new THREE.Mesh( TitleGeom, TitleMat );
	scene.add(TitleMesh);
	
	var BackGeom = new THREE.PlaneGeometry( 50, 50 );
	var BackMat = new THREE.MeshBasicMaterial(  );	
	BackMat.transparent = true;
	BackMat.color.set(0);
	BackMesh = new THREE.Mesh( BackGeom, BackMat );
	scene.add(BackMesh);
			
	InterfLoaded = true;
	
	++waitCount;
}


function on_model_load( object ) {

	var dae = object.scene;
	dae.updateMatrix();
	
	var LastFoundMesh;

	dae.traverse( function ( child ) {

		if ( child instanceof THREE.Mesh ) {
			child.material = material;
			LastFoundMesh = child;
		}

	} );
	
	MainCharacterMesh = new THREE.Mesh( LastFoundMesh.geometry, LastFoundMesh.material );
	
	MainCharacterMesh.position.x = 9;
	MainCharacterMesh.position.y = 56;
	MainCharacterMesh.position.z = 0;
	
	MainCharacter = new CharacterObj(MainCharacterMesh, CharacterStyle.Current);
	
	
	CurrentRespawnPosition = MainCharacter.Object.position.clone();
	
	// Create enemies :
	
	for( var i=0; i<CharacReplayNumber; ++i) {
	
		var CurUni = {
			time: { type: "f", value: 1.0 },
			col: { type: "v4", value: new THREE.Vector4(0.8,0.8,1.0,1.0) },
			texture: { type: "t", value: MainTex },
			pivot: { type: "v4v", value: MainPivot },
			motion: { type: "v4v", value: MainMotion },
			random: { type: "fv1", value: GetRandomSkelet() }
		};
	
		var CharacMat = LastFoundMesh.material.clone();
		CharacMat.uniforms = CurUni;
		
		var NewMesh = new THREE.Mesh( LastFoundMesh.geometry, CharacMat );
		
		NewMesh.position.x = 1000;
		NewMesh.position.y = 1000;
		NewMesh.position.z = i*0.1;
		
		var NewCharac = new CharacterObj(NewMesh, CharacterStyle.Replay);
		
		if(i == CharacSpawnerIdx) {
			NewCharac.IsSpawner = true;
		}
		
		CharacReplay.push( NewCharac );
		CharacReccord.push( new Reccord() );
		scene.add( NewMesh );
	}
	
	var AvanceEnemy = 12;
	
	EnemyNb = CurrentLevel.SpawnsX.length;
	
	for( var i=0; i<EnemyNb; ++i) {
	
		var CurUni = {
			time: { type: "f", value: 1.0 },
			col: { type: "v4", value: new THREE.Vector4(1.0,0.6,0.6,1.0) },
			texture: { type: "t", value: MainTex },
			pivot: { type: "v4v", value: MainPivot },
			motion: { type: "v4v", value: MainMotion },
			random: { type: "fv1", value: GetRandomSkelet() }
		};
	
		var EnemyMat = LastFoundMesh.material.clone();
		EnemyMat.uniforms = CurUni;
		
		var NewMesh = new THREE.Mesh( LastFoundMesh.geometry, EnemyMat );
		
		if(CurrentLevel.SpawnsX.length > i) {
			NewMesh.position.x = CurrentLevel.SpawnsX[i] + Math.random()-0.5;
			NewMesh.position.y = CurrentLevel.SpawnsY[i];
			NewMesh.position.z = i*0.01;
		} else {
			NewMesh.position.x = AvanceEnemy;
			NewMesh.position.y = 60 - Math.floor(i/50)*0.1;
			NewMesh.position.z = i*0.01;
			AvanceEnemy += Math.random()*0.6+0.2;
		}
		
		var NewEnemy = new CharacterObj(NewMesh, CharacterStyle.Enemy);
		
		AllEnemies.push( NewEnemy );
		scene.add( NewMesh );
	}
	
	//dae.position.y = - 8;
	//scene.add( dae );
	//AllObj.push(dae);
	
	MainCharacLoaded = true;
	
	++waitCount;
}

function OnLevelLoad(object) {
		
	LevelTex.image = object.image;
	LevelTex.needsUpdate = true;
	
	CurrentLevel = new Level(LevelTex.image);
	
	var LevelDebugGeom = new THREE.PlaneGeometry( 128, 128 );
	
	var InvScale = 1.0/CurrentLevel.Scale;
	
	LevelDebugMesh = new THREE.Mesh( LevelDebugGeom, LevelMat );
	LevelDebugMesh.position.x = 64*InvScale;
	LevelDebugMesh.position.y = 64*InvScale;
	LevelDebugMesh.position.z = -1;
	LevelDebugMesh.scale.set(InvScale, InvScale, InvScale);
		
	var CrossGeom = new THREE.PlaneGeometry( 1, 1 );
	var CrossMat = new THREE.MeshBasicMaterial( {map: CrossTex, depthWrite: false, depthTest: false, transparent : true });
	CrossMesh = new THREE.Mesh( CrossGeom, CrossMat );
	var CrossInvScale = 1.0/CurrentLevel.Scale;
	CrossMesh.position.z = 1.0;
	CrossMesh.scale.set(CrossInvScale, CrossInvScale, CrossInvScale);
		
	/*
	for(var i=0; i<30; ++i) {
		var DebugGeom = new THREE.PlaneGeometry( 1, 1 );
		var DebugMat = new THREE.MeshBasicMaterial();				
		var DebugMesh = new THREE.Mesh( DebugGeom, DebugMat );
		var DebugInvScale = 1.0/CurrentLevel.Scale;
		LevelDebugMesh.position.z = -0.1;
		DebugMesh.scale.set(DebugInvScale, DebugInvScale, DebugInvScale);
		//DebugMesh.material.color.setRGB(1,0,0);
		DebugPlanes.push(DebugMesh);
		scene.add( DebugMesh );
	}*/
	
	CurrentLevelLoaded = true;	
	++waitCount;
	
	// model
	
	var loader = new THREE.ColladaLoader();
	loader.options.convertUpAxis = true;
	loader.load( 'Export/SkelTest3.dae', on_model_load);

	loader.load( 'Export/Interface_1.dae', on_interf_load);
}

function GetRandomSkelet() {
	var TextureSizeX = 1024.0;
	//var PartTexSizeX =[75,92,121,56,46,113,130,123,129,99,91,106,69];
	var PartTexSizeX =[75,92,121,56,46,113,130,123,129,99,91,106,69,130,113,91,99,106,69];
	var PartTexNumX =[6,11,7,9,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6];
		
	var CurRand = [];
	for(var i=0; i<PartTexSizeX.length; ++i) {
		var RandVal = Math.floor(Math.random()*PartTexNumX[i]);
		var TexScale = RandVal * PartTexSizeX[i] / TextureSizeX;
		CurRand.push( TexScale );
	}
		
	return CurRand;
}

function GetRandomInterf() {
	var CurRand = [];
	for(var i=0; i<11; ++i) {
		CurRand.push( 0.0 );
	}		
	return CurRand;
}

function init() {

	container = document.createElement( 'div' );
	document.body.appendChild( container );
	
	windowHalfX = window.innerWidth / 2;
	windowHalfY = window.innerHeight / 2;
	
	var MaxScreen = Math.max(1.0, Math.min(windowHalfX, windowHalfY) * 2.0);
	CamZoom = CamBaseZoom * ScreenRef / MaxScreen;
	
	var CamSizeX = CamZoom * windowHalfX;
	var CamSizeY = CamZoom * windowHalfY;

	//camera = new THREE.PerspectiveCamera( 2, window.innerWidth / window.innerHeight, 0.1, 1000 );
	camera = new THREE.OrthographicCamera( -CamSizeX, CamSizeX, CamSizeY, -CamSizeY, 0.1, 1000 );
		
	camera.position.set( 0, 0, 100 );
	camera.lookAt( new THREE.Vector3(0,0,0) );

	// scene

	scene = new THREE.Scene();
	
	// texture

	var manager = new THREE.LoadingManager();
	manager.onProgress = function ( item, loaded, total ) {

		console.log( item, loaded, total );

	};

	MainTex = new THREE.Texture();
	InterfTex = new THREE.Texture();
	ParticleTex = new THREE.Texture();
	CrossTex = new THREE.Texture();
	LevelTex = new THREE.Texture();
	LevelBackgroundTex = new THREE.Texture();
	LevelGroundTex = new THREE.Texture();
	TitleTex1 = new THREE.Texture();
	TitleTex2 = new THREE.Texture();

	var loader = new THREE.ImageLoader( manager );
	loader.load( 'textures/Planche_08.png', function ( image ) {

		MainTex.image = image;
		MainTex.needsUpdate = true;
		++waitCount;

	} );
	
	loader.load( 'textures/Interface_Skel_Complet.png', function ( image ) {

		InterfTex.image = image;
		InterfTex.needsUpdate = true;
		++waitCount;

	} );
	
	loader.load( 'textures/Fire_2.png', function ( image ) {

		ParticleTex.image = image;
		ParticleTex.needsUpdate = true;
		++waitCount;

	} );
	
	loader.load( 'textures/Cross_2.png', function ( image ) {

		CrossTex.image = image;
		CrossTex.needsUpdate = true;
		++waitCount;

	} );
	
	loader.load( 'textures/Background.jpg', function ( image ) {

		LevelBackgroundTex.image = image;
		LevelBackgroundTex.needsUpdate = true;
		++waitCount;

	} );
	
	loader.load( 'textures/Ground.jpg', function ( image ) {

		LevelGroundTex.image = image;
		LevelGroundTex.needsUpdate = true;
		++waitCount;

	} );
	
	loader.load( 'textures/Title.jpg', function ( image ) {

		TitleTex1.image = image;
		TitleTex1.needsUpdate = true;
		++waitCount;

	} );
	
	loader.load( 'textures/Title2.png', function ( image ) {

		TitleTex2.image = image;
		TitleTex2.needsUpdate = true;
		++waitCount;

	} );
	
	// shader and material
		
	MainRandom = GetRandomSkelet();
	
	// Skull				0
	MainPivot.push( new THREE.Vector4(-0.002,0.3,8.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.8,0.2,0.0,0.0) );
	// Hair				1
	MainPivot.push( new THREE.Vector4(-0.002,0.3,0.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.0,0.0,0.0,0.0) );
	// Hat				2
	MainPivot.push( new THREE.Vector4(-0.002,0.3,0.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.0,0.0,0.0,0.0) );
	// Eyes				3
	MainPivot.push( new THREE.Vector4(-0.002,0.3,0.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.0,0.0,0.0,0.0) );
	// Lips				4
	MainPivot.push( new THREE.Vector4(-0.002,0.3,0.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.0,0.0,0.0,0.0) );
	// LegBottomLeft	5
	MainPivot.push( new THREE.Vector4(-0.050,-0.21,6.0,19.0) );
	MainMotion.push( new THREE.Vector4(1.0,-0.5,0.0,0.0) );
	// LegTopLeft		6
	MainPivot.push( new THREE.Vector4(-0.043,-0.027,19.0,19.0) );
	MainMotion.push( new THREE.Vector4(1.0,0.0,0.0,0.0) );
	// Middle			7
	MainPivot.push( new THREE.Vector4(0.010,0.043,19.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.2,0.2,0.0,0.0) );
	// Top				8
	MainPivot.push( new THREE.Vector4(0.015,0.068,19.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.1,1.3,0.0,0.0) );
	// ArmLeft			9
	MainPivot.push( new THREE.Vector4(-0.044,0.220,19.0,19.0) );
	MainMotion.push( new THREE.Vector4(1.0,1.0,0.0,0.0) );
	// FootLeft			10
	MainPivot.push( new THREE.Vector4(-0.047,-0.397,5.0,19.0) );
	MainMotion.push( new THREE.Vector4(2.0,0.75,0.0,0.0) );
	// ForeArmLeft		11
	MainPivot.push( new THREE.Vector4(-0.174,0.2123,9.0,19.0) );
	MainMotion.push( new THREE.Vector4(2.0,1.25,0.0,0.0) );
	// HandLeft			12	
	MainPivot.push( new THREE.Vector4(-0.312,0.203,11.0,0.0) );
	MainMotion.push( new THREE.Vector4(2.0,0.45,0.0,0.0) );
	// LegTopRight		13
	MainPivot.push( new THREE.Vector4(0.053,-0.025,19.0,19.0) );
	MainMotion.push( new THREE.Vector4(1.0,1.0,0.0,0.0) );
	// LegBottomRight	14
	MainPivot.push( new THREE.Vector4(0.052,-0.213,13.0,19.0) );
	MainMotion.push( new THREE.Vector4(1.0,0.5,0.0,0.0) );
	// FootRight		15	
	MainPivot.push( new THREE.Vector4(0.051,-0.401,14.0,19.0) );
	MainMotion.push( new THREE.Vector4(2.0,1.75,0.0,0.0) );
	// ArmRight			16
	MainPivot.push( new THREE.Vector4(0.077,0.226,19.0,19.0) );
	MainMotion.push( new THREE.Vector4(1.0,0.0,0.0,0.0) );
	// ForeArmRight		17
	MainPivot.push( new THREE.Vector4(-0.056,0.220,16.0,19.0) );
	MainMotion.push( new THREE.Vector4(2.0,0.25,0.0,0.0) );
	// HandRight		18
	MainPivot.push( new THREE.Vector4(-0.19,0.209,17.0,0.0) );
	MainMotion.push( new THREE.Vector4(2.0,1.45,0.0,0.0) );
	// NullPivot		19
	MainPivot.push( new THREE.Vector4(0.0,0.0,19.0,19.0) );
	MainMotion.push( new THREE.Vector4(0.0,0.0,0.0,0.0) );
	
	MainUni = {
		time: { type: "f", value: 1.0 },
		col: { type: "v4", value: new THREE.Vector4(0.8,1.0,0.8,1.0) },
		texture: { type: "t", value: MainTex },
		pivot: { type: "v4v", value: MainPivot },
		motion: { type: "v4v", value: MainMotion },
		random: { type: "fv1", value: MainRandom }
	};
	
	MainUni.texture.value.wrapS = MainUni.texture.value.wrapT = THREE.RepeatWrapping;

	material = new THREE.ShaderMaterial( {

		uniforms: MainUni,
		vertexShader: document.getElementById( 'CharacVS' ).textContent,
		fragmentShader: document.getElementById( 'CharacPS' ).textContent

	} );
	
	material.vertexColors = THREE.VertexColors;
	material.transparent = true;
	material.depthWrite = false;
	material.depthTest = false;
	material.side = THREE.DoubleSide;
	
	InterfRandom = GetRandomInterf();
	
	InterfUni = {
		time: { type: "f", value: 1.0 },
		col: { type: "v4", value: new THREE.Vector4(1.0,1.0,1.0,1.0) },
		texture: { type: "t", value: InterfTex },
		random: { type: "fv1", value: InterfRandom }
	};
		
	InterfMaterial = new THREE.ShaderMaterial( {

		uniforms: InterfUni,
		vertexShader: document.getElementById( 'InterfVS' ).textContent,
		fragmentShader: document.getElementById( 'InterfPS' ).textContent

	} );
	
	InterfMaterial.vertexColors = THREE.VertexColors;
	InterfMaterial.transparent = true;
	InterfMaterial.depthWrite = false;
	InterfMaterial.depthTest = true;
	InterfMaterial.side = THREE.DoubleSide;
	
	LevelBackgroundTex.wrapS = THREE.RepeatWrapping;
	LevelBackgroundTex.wrapT = THREE.RepeatWrapping;
	LevelGroundTex.wrapS = THREE.RepeatWrapping;
	LevelGroundTex.wrapT = THREE.RepeatWrapping;
	
	LevelUni = {
		time: { type: "f", value: 1.0 },
		texture: { type: "t", value: LevelTex },
		background: { type: "t", value: LevelBackgroundTex},
		ground: { type: "t", value: LevelGroundTex }
	};
	
	LevelMat = new THREE.ShaderMaterial( {

		uniforms: LevelUni,
		vertexShader: document.getElementById( 'LevelVS' ).textContent,
		fragmentShader: document.getElementById( 'LevelPS' ).textContent

	} );

	LevelMat.transparent = true;
	LevelMat.depthWrite = false;
	LevelMat.depthTest = false;
	LevelMat.side = THREE.DoubleSide;
		
	// Load level :
	
	var level01tex = THREE.ImageUtils.loadTexture( "textures/Level_01.png", undefined, OnLevelLoad );

	//

	renderer = new THREE.WebGLRenderer();
	renderer.setSize( window.innerWidth, window.innerHeight );
	container.appendChild( renderer.domElement );
	
	//
	
	stats = new Stats();
	stats.domElement.style.position = 'absolute';
	stats.domElement.style.top = '0px';
	container.appendChild( stats.domElement );

	
	// Particles :
	
	//Particles.push( new PartSystem( new THREE.Vector2(-1.0,0.0)) );

	window.addEventListener( 'resize', onWindowResize, false );
	
	document.addEventListener( 'keydown', onKeyDown, false );
	document.addEventListener( 'keyup', onKeyUp, false );
	document.addEventListener( 'mousemove', onDocumentMouseMove, false );
	document.addEventListener( 'mousedown', onMouseDown, false );
	document.addEventListener( 'mouseup', onMouseUp, false );
}

function onKeyDown( event ) {
	if(event.keyCode == 37) { // Key Left
		InputSample.KeyLeft = true;
	} else if(event.keyCode == 39) { // Key Right
		InputSample.KeyRight = true;
	} else if(event.keyCode == 38) { // Key Up
		InputSample.KeyUp = true;
	} else if(event.keyCode == 40) { // Key Down
		InputSample.KeyDown = true;
	}
}

function onKeyUp( event ) {
	if(event.keyCode == 37) { // Key Left
		InputSample.KeyLeft = false;
	} else if(event.keyCode == 39) { // Key Right
		InputSample.KeyRight = false;
	} else if(event.keyCode == 38) { // Key Up
		InputSample.KeyUp = false;
	} else if(event.keyCode == 40) { // Key Down
		InputSample.KeyDown = false;
	}
}

function onDocumentMouseMove( event ) {
	MouseX = event.clientX - windowHalfX;
	MouseY = event.clientY - windowHalfY;
}

function onMouseDown( event ) {
	InputSample.MouseDown = true;
	event.preventDefault();	
}

function onMouseUp( event ) {
	InputSample.MouseDown = false;
	event.preventDefault();
	
	if(TitleClic1) {
		TitleClic2 = true;
	} else {
		TitleClic1 = true
	}
}

function onWindowResize() {

	windowHalfX = window.innerWidth / 2;
	windowHalfY = window.innerHeight / 2;

	var CamSizeX = CamZoom * windowHalfX;
	var CamSizeY = CamZoom * windowHalfY;

	camera.left = -CamSizeX;
	camera.right = CamSizeX;
	camera.top = CamSizeY;
	camera.bottom = -CamSizeY;
	
	//camera.aspect = window.innerWidth / window.innerHeight;
	camera.updateProjectionMatrix();

	renderer.setSize( window.innerWidth, window.innerHeight );

	//controls.handleResize();
}

function IsAllLoaded() {
	return CurrentLevelLoaded && MainCharacLoaded && InterfLoaded && AllIsLoaded && TitleClic1 && TitleClic2;
	//return CurrentLevelLoaded && MainCharacLoaded && InterfLoaded && AllIsLoaded;
}

//

function animate() {

	requestAnimationFrame( animate );
		
	var Delta = clock.getDelta(),
		Time = clock.getElapsedTime();
		
	if(!TickStarted) {
		TickStarted = true;
		LastTickTime = Time;
	}
	
	var LastFrameDuration = Time-LastTickTime + RestTickTime;
	LastTickTime = Time;
	
	var ToTick = Math.floor(TickRate*LastFrameDuration);
	var TickNeeded = Math.min(ToTick, 10);
	RestTickTime = LastFrameDuration - ToTick/TickRate;
	
	for(var i=0; i<TickNeeded; ++i) {
		TickWorld();
	}
	
	Render(Time, Delta);

	stats.update();
}

function ResetBeforeReplay() {

	var RealMaxReccord = Math.min(MaxReccord, CharacReplayNumber);

	for(var i=0; i<RealMaxReccord; ++i) {
		CharacReplay[i].Reset();
		CharacReplay[i].Object.position.copy(CharacReccord[i].Samples[0].CurrentPosition);
	}

	for(var i=0; i<AllEnemies.length; ++i) {
		AllEnemies[i].Reset();
	}
	
	for(var i=0; i<Particles.length; ++i) {
		if(!Particles[i].Dead) {
			scene.remove( Particles[i].Object );
		}
	}
	Particles.length = 0;

}

function KeepState() {

	var RealMaxReccord = Math.min(MaxReccord, CharacReplayNumber);

	for(var i=0; i<RealMaxReccord; ++i) {
		CharacReplay[i].KeepState();
	}

	for(var i=0; i<AllEnemies.length; ++i) {
		AllEnemies[i].KeepState();
	}
}

function TickWorld() {
	
	if(!IsAllLoaded())
		return;
		
	var CurMouseX = MouseX;
	var CurMouseY = MouseY;
	
	var ScaleMouseX = CamZoom*1.0;
	var ScaleMouseY = CamZoom*1.0;
	
	var LocalMousePosition = new THREE.Vector3();
	LocalMousePosition.x = camera.position.x + CurMouseX * ScaleMouseX;
	LocalMousePosition.y = camera.position.y - CurMouseY * ScaleMouseY;
	LocalMousePosition.z = 0.0;
	
	CrossMesh.position.copy(LocalMousePosition);
	
	InputSample.CurrentPosition.copy(MainCharacter.Object.position);
	InputSample.MouseLocation.copy(LocalMousePosition);
	
	var CurrentSample = InputSample.Clone();

	//-------------
	
/*	
	var CharacReplay = [];
	var CharacReccord = [];
	var CharacReplayNumber = 5:
	var CharacSpawnerIdx = 4;
	var CurrentReccord = 0;
	
	CurrentRespawnPosition
	*/
	
	
	var IsRespawn = false;
	if(CurrentReccord >= CharacReplayNumber) {
		CurrentReccord = 0;
		IsRespawn = true;
	}
	
	if(CurrentReccord < CharacReplayNumber) {
		if(ReccordTickFrame == 0) {
			CharacReccord[CurrentReccord].CleanReccord();
			CharacReplay[CurrentReccord].Reset();
			CharacReplay[CurrentReccord].Object.position.x = 1000.0;
			CharacReplay[CurrentReccord].Object.position.y = 1000.0;
		}
		if(CharacReccord[CurrentReccord].AddReccord(CurrentSample.Clone())) {
			++ReccordTickFrame;
		} else {
			if(MainCharacter.Dead) {
				CharacReccord[CurrentReccord].DeathDuring = true;
			}
		
			// Show the corresponding charac :
			//scene.add(CharacReplay[CurrentReccord].Object);
			
			var TmpUni = MainCharacter.Object.material.uniforms.random.value;
			MainCharacter.Object.material.uniforms.random.value = CharacReplay[CurrentReccord].Object.material.uniforms.random.value;
			CharacReplay[CurrentReccord].Object.material.uniforms.random.value = TmpUni;
			
			if(CurrentReccord == CharacReplayNumber-1) {
				KeepState();
			} else {
				MainCharacter.Reset();
				MainCharacter.Object.position.copy(CurrentRespawnPosition);
			}
			
			ReccordTickFrame = 0;
			++CurrentReccord;		
			ReplayTickFrame = 0;
		}
	}
	
	MaxReccord = Math.max(MaxReccord, CurrentReccord);
	var RealCurrentReccord = Math.min(MaxReccord, CharacReplayNumber);
		
	if(ReplayTickFrame == 0) {
		ResetBeforeReplay();		
	}
	
	if(IsRespawn) {
		CurrentRespawnPosition.copy(MainCharacter.Object.position);
	}
	
	for(var i=0; i<RealCurrentReccord; ++i) {
		if(ReplayTickFrame<CharacReccord[i].Samples.length) {
			CharacReplay[i].EnemyCol();
			CharacReplay[i].KeyMove(CharacReccord[i].Samples[ReplayTickFrame]);
		}
	}
	
	++ReplayTickFrame;
	if(ReplayTickFrame>ReccordDurationFrame) {
		ReplayTickFrame = 0;
	}
		
	MainCharacter.EnemyCol();
	MainCharacter.KeyMove(CurrentSample);
	
	//-------------
	
	var InterfChunkSize = 82.0/512.0;
	
	for(var i=0; i<5; ++i) {
		var Base = CurrentReccord >= i ? 3 : 0;
		if(CurrentReccord >= i) {
			if(i==CharacSpawnerIdx) {
				Base = 2;
			}
		}
		if(CurrentReccord == i && MainCharacter.Dead) {
			Base = 4;
		}
		if(CurrentReccord > i && CharacReplay[i].Dead) {
			Base = 4;
		}

		InterfRandom[i] = Base * InterfChunkSize;
	}	
	for(var i=0; i<5; ++i) {
		var Base = 4;
		if(CurrentReccord > i) {
			if(CharacReccord[i].DeathDuring) {
				Base = 0;
			}
		}
		InterfRandom[i+5] = Base * InterfChunkSize;
	}	
	
	/*
	for(var i=0; i<10; ++i) {
		InterfRandom[i] = Math.random();
	}*/

	var MaxScale = 0.8;
	var NewScale = (CurrentReccord>0 ? ReplayTickFrame : ReccordTickFrame) / ReccordDurationFrame;
	
	TimeBarMesh.scale.x = Math.max(NewScale, 0.001) * MaxScale;
	TimeBarMesh.scale.y = 0.1;
	TimeBarMesh.scale.z = 0.1;
	TimeBarMesh.material.color.setRGB(1,0,0);
	
	TimeBarMesh.position.x = MainCharacter.Object.position.x - MaxScale + TimeBarMesh.scale.x * 0.5 + 1.91;
	TimeBarMesh.position.y = MainCharacter.Object.position.y + 1.85;
	TimeBarMesh.position.z = MainCharacter.Object.position.z + 4.0;	
	
	Interface.position.x = MainCharacter.Object.position.x + 2;
	Interface.position.y = MainCharacter.Object.position.y + 2;
	Interface.position.z = MainCharacter.Object.position.z + 4.8;
		
	for(var i=0; i<AllEnemies.length; ++i) {
		var EnemyInput = new ReccordSample();
		
		AllEnemies[i].ParticleCol();
		AllEnemies[i].KeyMove(EnemyInput);
	}
		
	//Particles[0].Object.position.copy(MainCharacter.Object.position);
	for(var i=0; i<Particles.length; ++i) {
		Particles[i].Tick();
	}
	
	var Avg = 0;
	/*
	for(var i=0; i<300000; ++i) {
		var RandX = Math.random() * 128;
		var RandY = Math.random() * 128;
		if(CurrentLevel.GetColl(RandX, RandY)) {
			Avg += 1;
		}
	}
	*/
	
	if(NextRandomChange == 0) {
		NextRandomChange = 60;
		//uniforms.random.value = GetRandomSkelet();
	} else {
		--NextRandomChange;
	}
	
	
	var CurTime = clock.getElapsedTime();
	camera.position.x = MainCharacter.Object.position.x;// + Math.cos(CurTime);
	camera.position.y = MainCharacter.Object.position.y;// + Math.sin(CurTime);
	camera.position.z = 150;
	
	//camera.lookAt( new THREE.Vector3(MainCharacter.Object.position.x, MainCharacter.Object.position.y, MainCharacter.Object.position.z) );
	
	PrevMouseX = MouseX;
	PrevMouseY = MouseY;
	
}

function Render(Time, DeltaTime) {

	/*
	for(var i=0; i<AllObj.length; ++i)
	{
		AllObj[i].;
	}
	*/
	
	var MaxScreen = Math.max(1.0, Math.min(windowHalfX, windowHalfY) * 2.0);
	CamZoom = CamBaseZoom * ScreenRef / MaxScreen;
	
	var waiting = document.getElementById( 'waiting' );
	var waitPercent = document.getElementById( 'waitPercent' );
	waitPercent.innerHTML = Math.floor((waitCount/waitNb)*100) + '%';
	if(waitCount == waitNb) {
		waiting.style.display = 'none';
		AllIsLoaded = true;
		
		scene.add( LevelDebugMesh );
		scene.add( MainCharacterMesh );
		
		scene.add( Interface );
		scene.add( TimeBarMesh );		
		
		scene.add( CrossMesh );
	}
		
	if(CurrentLevelLoaded && MainCharacLoaded && InterfLoaded && AllIsLoaded) {
		TitleMesh.position.x = 0.0;
		TitleMesh.position.y = 0.0;
		TitleMesh.position.z = 50.0;
		
		BackMesh.position.x = 0.0;
		BackMesh.position.y = 0.0;
		BackMesh.position.z = 45.0;
		
		if(TitleClic1) {
			TitleMesh.material.map = TitleTex2;
		} else if(TitleClic2 && !TitleClic3) {
			scene.remove(TitleMesh);
			scene.remove(BackMesh);
			TitleClic3 = true;
		}		
	}
	
	if(IsAllLoaded()) {
	
		MainCharacter.RenderUpdate(Time, DeltaTime);
		
		for(var i=0; i<AllEnemies.length; ++i) {
			AllEnemies[i].RenderUpdate(Time, DeltaTime);
		}
		
		for(var i=0; i<CurrentReccord; ++i) {
			CharacReplay[i].RenderUpdate(Time, DeltaTime);
		}
		
		LevelUni.time.value = Time;
		InterfUni.time.value = Time;
		//uniforms.time.value = Time;
	}	
	renderer.render( scene, camera );
}