
PartSystem = function ( Direction ) {
	
	this.Direction = Direction.clone();
	this.TestLocation = new THREE.Vector3(0.0,0.0,0.0);
	var geometry = new THREE.Geometry();
	
	this.Frame = 0;
	this.Randoms = [];
	this.Duration = 60;
	this.Dead = false;
	this.Killing = true;
	
	for ( var i = 0; i < 30; i ++ ) {
		var RandScale = Math.random() + 0.5;
		var RandAngle = (Math.random() - 0.5)*0.3;
		
		var CosAngle = Math.cos(RandAngle);
		var SinAngle = Math.sin(RandAngle)
		;
		var Dir = new THREE.Vector2();
		Dir.x = (Direction.x*CosAngle - Direction.y*SinAngle)*RandScale;
		Dir.y = (Direction.x*SinAngle + Direction.y*CosAngle)*RandScale;
		this.Randoms.push(Dir);
		var vertex = new THREE.Vector3(0.0,0.0,0.0);
		geometry.vertices.push( vertex );
	}
	// size: size, map: sprite, blending: THREE.AdditiveBlending, depthTest: false, transparent : true
	var c = new THREE.Color().setRGB( 1.0, 1.0, 0.66 );
	this.Object = new THREE.ParticleSystem( geometry, new THREE.ParticleBasicMaterial( { size: 38, sizeAttenuation: false, map: ParticleTex, color: c, depthWrite: false, depthTest: false, transparent : true } ) );
		
	scene.add( this.Object );
};

PartSystem.prototype = {

	constructor: PartSystem,
	
	Tick: function( )
	{	
		if(this.Dead)
			return false;
			
		var Time = FixedDeltaTime * this.Frame * 3.0;
		
		var DecalTestX = -0.5/CurrentLevel.Scale;
		var DecalTestY = -0.5/CurrentLevel.Scale;
		var BaseLoc = this.Object.position.clone();
		//BaseLoc.x += DecalTestX;
		//BaseLoc.y += DecalTestY;
	
		var Vertices = this.Object.geometry.vertices;
		for(var i=0; i<Vertices.length; ++i) {
			Vertices[i].x = this.Randoms[i].x * Time;
			Vertices[i].y = this.Randoms[i].y * Time;
			Vertices[i].z = 0.0;
			
			if(CurrentLevel.GetColl(Vertices[i].x+BaseLoc.x, Vertices[i].y+BaseLoc.y)) {
				this.Randoms[i].x = 10000.0;
				this.Randoms[i].y = 10000.0;
			}
		}
		
		this.TestLocation.copy(this.Direction);
		this.TestLocation.multiplyScalar(Time);
		this.TestLocation.add(this.Object.position);
		
		var AlphaAnim = this.Frame/this.Duration;
		this.Object.material.opacity = Math.max(0.0, (0.5-AlphaAnim)*2.0);
		
		this.Object.geometry.verticesNeedUpdate = true;
		
		if(this.Frame > 35)
			this.Killing = false;
		
		++this.Frame;
		if(this.Frame>this.Duration) {
			this.Dead = true;
			this.Killing = false;
			scene.remove( this.Object );
			return false;
		}
		return true;
	},
			
};